//########## Silent Reaper

//### Sounds

datablock AudioProfile(gc_SRFireSound)
{
  filename = "./silentreaper.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_THHit1Sound)
{
  filename = "./hit1.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_THHit2Sound)
{
  filename = "./hit2.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_SRFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 1 1";
  colors[1] = "0.4 0.4 0.4 0.5";
  colors[2] = "0.2 0.2 0.2 0";
  sizes[0] = 0.1;
  sizes[1] = 0.2;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.3;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_SRFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 50;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_SRFlashParticle";
};

datablock ParticleData(gc_SRArchParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "./arch";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.0 0 1";
  colors[1] = "1 0.6 0.2 1";
  colors[2] = "1 0.0 0 0";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.3;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_SRArchEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 50;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  orientParticles = true;
  overrideAdvance = false;
  particles = "gc_SRArchParticle";
};

datablock ParticleData(gc_SRSmokeParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 500;
  lifetimeVarianceMS = 250;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -5;
  spinRandomMax = 5;
  colors[0] = "1 0 0 1";
  colors[1] = "0.4 0.2 0.2 0.5";
  colors[2] = "0.2 0.2 0.2 0";
  sizes[0] = 0.5;
  sizes[1] = 1;
  sizes[2] = 2;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_SRSmokeEmitter)
{
  uiName = "";
  lifetimeMS = 100;
  ejectionPeriodMS = 10;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = false;
  particles = "gc_SRSmokeParticle";
};

datablock ExplosionData(gc_SRExplosion)
{
  lifeTimeMS = 50;
  emitter[0] = gc_SRArchEmitter;
  emitter[1] = gc_SRSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 1;
};

datablock DebrisData(gc_THShellDebris)
{
  shapeFile = "./shell.dts";
  lifetime = 2;
  minSpinSpeed = -400;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

//### Projectile

AddDamageType("gc_SR",'<bitmap:Add-ons/Weapon_SilentReaper/CI_silentreaper> %1','%2 <bitmap:Add-ons/Weapon_SilentReaper/CI_silentreaper> %1',0.2,1);

datablock ProjectileData(gc_SRProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 20;
  directDamageType = $DamageType::gc_SR;
  radiusDamageType = $DamageType::gc_SR;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 20;
  brickExplosionMaxVolume = 12;
  brickExplosionMaxVolumeFloating = 12;
  impactImpulse = 1000;
  verticalImpulse = 300;
  explosion = gc_SRExplosion;
  muzzleVelocity = 100;
  verInheritFactor = 1;
  lifetime = 3000;
  fadeDelay = 1500;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
};

//### Item

datablock ItemData(gc_SRItem)
{
  uiName = "Silent Reaper";
  iconName = "./icon_silentreaper";
  image = gc_SRImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./silentreaper.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(gc_SRImage)
{
  shapeFile = "./silentreaper.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_SRItem;
  ammo = "";
  projectile = gc_SRProjectile;
  projectileType = Projectile;
  casing = gc_THShellDebris;
  shellExitDir = "1 -1 0";
  shellExitVariance = 10;
  shellVelocity = 8;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire1";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire1";
  stateTransitionOnTimeout[2] = "Reload";
  stateTimeoutValue[2] = "0.08";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gc_SRFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzlePoint";
  stateSound[2] = gc_SRFireSound;
  stateScript[2] = "onFire1";
  stateEjectShell[2] = true;
  stateSequence[2] = "Fire";

  stateName[3] = "Fire2";
  stateTransitionOnTimeout[3] = "Reload";
  stateTimeoutValue[3] = "0.08";
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateWaitForTimeout[3] = true;
  stateEmitter[3] = gc_SRFlashEmitter;
  stateEmitterTime[3] = 0.05;
  stateEmitterNode[3] = "muzzlePoint";
  stateSound[3] = gc_SRFireSound;
  stateScript[3] = "onFire2";
  stateEjectShell[3] = true;
  stateSequence[3] = "Fire";

  stateName[4] = "Reload";
  stateTimeoutValue[4] = 0.01;
  stateTransitionOnTriggerUp[4] = "Ready";
  stateTransitionOnTimeout[4] = "Fire2";
};

function gc_SRImage::onFire1(%this,%obj,%slot)
{
  %spread = 0.0005;
  if(%obj.isCrouched() == 1) %spread -= 0.0002;
//  if(vectorLen(%obj.getVelocity()) >= 5 && !isObject(%obj.getObjectMount())) %spread += 0.001;
  
  %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(0),%this.projectile.muzzleVelocity));
    initialPosition = %obj.getMuzzlePoint(0);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
}

function gc_SRImage::onFire2(%this,%obj,%slot)
{
  %spread = 0.0015;
  if(%obj.isCrouched() == 1) %spread -= 0.0001;
//  if(vectorLen(%obj.getVelocity()) >= 5 && !isObject(%obj.getObjectMount())) %spread += 0.001;
  
  %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(0),%this.projectile.muzzleVelocity));
    initialPosition = %obj.getMuzzlePoint(0);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
}

function gc_SRProjectile::onCollision(%this,%obj,%col,%fade,%pos,%norm)
{
  if(getRandom(1,2) == 1) serverPlay3D(gc_THHit1Sound,%obj.getTransform());
  else
    serverPlay3D(gc_THHit2Sound,%obj.getTransform());
  parent::onCollision(%this,%obj,%col,%fade,%pos,%norm);
}
